; Set environment.
SetBatchLines, -1
SetControlDelay, -1
DetectHiddenWindows, On
SetWorkingDir, %A_ScriptDir%

; Build main GUI.
GoSub, Gui_Build_Main

Return ; End of auto-execute section.


Gui_Build_Main:
{
    ; Build GUI.
    Gui, Margin, 3, 5
    Gui, Add, Text    , xm     ym    w90  h20 Right 0x200                                       , Source folder:
    Gui, Add, Edit    , xm+95  ym    w270 h20                vSource_edt                        ,
    Gui, Add, Button  , xm+370 ym    w30  h20                vSource_btn         gBrowse        , ...
    Gui, Add, Text    , xm     ym+25 w90  h20 Right 0x200                                       , Destination folder:
    Gui, Add, Edit    , xm+95  ym+25 w270 h20                vDest_edt                          ,
    Gui, Add, Button  , xm+370 ym+25 w30  h20                vDest_btn gBrowse                  , ...
    Gui, Add, Checkbox, xm     ym+55 w120 h20                vShow_Folder_cbx                   , Show folder after run
    Gui, Add, GroupBox, xm+130 ym+45 w170 h35                                                   ,
    Gui, Add, Radio   , xm+140 ym+55 w70  h20 Checked        vCopy_rdo                          , Copy files
    Gui, Add, Radio   , xm+220 ym+55 w70  h20                vMove_rdo                          , Move files
    Gui, Add, Button  , xm+320 ym+53 w80  h25                vCreate_Folders_btn gCreate_Folders, &Create folders
    Gui, Add, Statusbar
        SB_SetText( "Ready.", 1 )
    GUI_ID := WinExist()
    Gui, Show, AutoSize Center, PDF Folder Builder
}
Return ; End of auto-execute section.


GuiEscape:
GuiClose:
{
    ExitApp
}
Return


Create_Folders:
{
    Gui, 1: Submit, NoHide

    ; Basic pre-check.
    If ( Source_edt = "" OR Dest_edt = "" OR ! FileExist( Source_edt ) OR ! FileExist( Dest_edt ) )
    {
        MsgBox, 48, Error, Please select both a valid source and destination folder.
        Return
    }

    ; PDF files are assumed to all be in the source folder.  No recursion necessary.
    ; Folder names are based off the initial 12 characters in the filename.
    Loop, %Source_edt%\*.pdf, 0, 0
    {
        SB_SetText( "Processing: " . A_LoopFileFullPath, 1 )
        StringLeft, Folder_Name, A_LoopFileName, 12
        If Not FileExist( Dest_edt . "\" . Folder_Name )
        {
            FileCreateDir, % Dest_edt . "\" . Folder_Name
        }

        ; No need to check for filename collisions.
        If ( Copy_rdo = 1 )
        {
            FileCopy, % A_LoopFileFullPath, % Dest_edt . "\" . Folder_Name . "\" . A_LoopFileName
        }
        Else If ( Move_rdo = 1 )
        {
            FileMove, % A_LoopFileFullPath, % Dest_edt . "\" . Folder_Name . "\" . A_LoopFileName
        }
    }

    SB_SetText( "Done.", 1 )
    If ( Show_Folder_cbx = 1 )
    {
        Run, % Dest_edt
    }
}
Return


Browse:
{
    Gui, 1: Submit, NoHide
    If ( A_GuiControl = "Source_btn" )
    {
        Source_Folder := ""
        FileSelectFolder, Source_Folder, , 2, Select source folder.
        If ( ErrorLevel != 1 )
        {
            GuiControl, Text, Source_edt, % Source_Folder
        }
    }
    Else If ( A_GuiControl = "Dest_btn" )
    {
        Dest_Folder := ""
        FileSelectFolder, Dest_Folder, , 2, Select destination folder.
        If ( ErrorLevel != 1 )
        {
            GuiControl, Text, Dest_edt, % Dest_Folder
        }
    }
    ; Right justify the edit control's content if longer than the control's length
    SendMessage, 0xB1, 500, 500, Edit1 ; 0xB1 is EM_SETSEL
    SendMessage, 0xB1, 500, 500, Edit2 ; 0xB1 is EM_SETSEL
}
Return
